#!/bin/sh

# serviio.SlackBuild: build script for Serviio DNLA Server

# Copyright 2016 Luís Fernando Carvalho Cavalheiro ( pessoal at profcavalheiro dot com)
# All rights reserved.
#
# Redistribution and use of this script, with or without modification, is
# permitted provided that the following conditions are met:
#
# 1. Redistributions of this script must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ''AS IS'' AND ANY EXPRESS OR IMPLIED
# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

PRGNAM=serviio
VERSION=${VERSION:-1.7.1.1}
BUILD=${BUILD:-1}
TAG=${TAG:-_SBo}

SERVIIOGID=${SERVIIOGID:-337}
SERVIIOUID=${SERVIIOUID:-337}

if ! grep -q "^serviio:" /etc/group; then
        echo "$0: Error: $PRGNAM group ($SERVIIOGID) doesn't exist."
        echo "$0: Try creating one with:"
        echo " # groupadd -g $SERVIIOGID $PRGNAM"
        exit 1
fi

if ! grep -q "^serviio:" /etc/passwd; then
        echo "$0: Error: $PRGNAM user ($SERVIIOUID) doesn't exist."
        echo "$0: Try creating one with:"
        echo " # useradd -u $SERVIIOUID -g $SERVIIOGID -d /opt/$PRGNAM $PRGNAM"
        exit 1
fi

if [ -z "$ARCH" ]; then
  case "$( uname -m )" in
    i?86) ARCH=i586 ;;
    arm*) ARCH=arm ;;
       *) ARCH=$( uname -m ) ;;
  esac
fi

CWD=$(pwd)
TMP=${TMP:-/tmp/SBo}
PKG=$TMP/package-$PRGNAM
OUTPUT=${OUTPUT:-/tmp}

if [ "$ARCH" = "i586" ]; then
  SLKCFLAGS="-O2 -march=i586 -mtune=i686"
  LIBDIRSUFFIX=""
elif [ "$ARCH" = "i686" ]; then
  SLKCFLAGS="-O2 -march=i686 -mtune=i686"
  LIBDIRSUFFIX=""
elif [ "$ARCH" = "x86_64" ]; then
  SLKCFLAGS="-O2 -fPIC"
  LIBDIRSUFFIX="64"
else
  SLKCFLAGS="-O2"
  LIBDIRSUFFIX=""
fi

set -e

rm -rf $PKG
mkdir -p $TMP $PKG $OUTPUT
cd $TMP
rm -rf $PRGNAM-$VERSION
tar xvf $CWD/$PRGNAM-$VERSION-linux.tar.gz
cd $PRGNAM-$VERSION
chown -R root:root .
find -L . \
  -type d -exec chmod 755 {} \; -o \
  -type f -exec chmod 644 {} \;

chmod 755 bin/*

mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
mv -t $PKG/usr/doc/$PRGNAM-$VERSION LICENCE.txt NOTICE.txt README.txt RELEASE_NOTES.txt 
cat $CWD/$PRGNAM.SlackBuild > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild

# Without this rc.serviio won't work
sed -i '/^exec /s:$: \& echo \$! > /var/run/serviio/serviio.pid:' bin/serviio.sh

mkdir -p $PKG/opt/$PRGNAM
mv -t $PKG/opt/$PRGNAM *

mkdir -p $PKG/etc/rc.d
install --mode=644 $CWD/rc.$PRGNAM $PKG/etc/rc.d/rc.$PRGNAM.new

mkdir -p $PKG/install
cat $CWD/slack-desc > $PKG/install/slack-desc
cat $CWD/doinst.sh > $PKG/install/doinst.sh

cd $PKG
/sbin/makepkg -l y -c n $OUTPUT/$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.${PKGTYPE:-tgz}
